#!/bin/sh
# Tagger-Kennzeichnung wiederkehrender Aufnahmen
# weinberg 20070114 V1.0
# weinberg 20070119 V1.1
# weinberg 20070122 V1.2
# weinberg 20070305 V1.3
# weinberg 20070305 V1.3.1
# weinberg 20070309 V1.4
# weinberg 20070309 V1.4.1
# weinberg 20070312 V2.0
# weinberg 20070415 V2.1

VERSION=21

TIMERCHECK=
let UPDATINGTIME=$(date "+%s")

# DIRTAGGER = hier liegen die 1.Wort-Dateien oder  1./2. Wort-Dateien (siehe u.g. Kommentare)
#             die Schreibweise kann "ABCD" "abcd" "Abcd" sein
DIRTAGGER=/media/hdd/weinbergtagger

# DIRMOVIE  = hier liegen standardmaessig die Dreamfilmaufnahmen
DIRMOVIE=/media/hdd/movie

# DIRTMP    = hier liegen standardmaessig die Temp-Dateien
DIRTMP=/var/tmp

# CRONFILE  = der Wert darf nicht geaendert werden!!
CRONFILE=/etc/cron/crontabs/root

# TIMERFILE = hier liegen die vorprogrammierten Aufnahmen
TIMERFILE=/etc/enigma2/timers.xml

[[ ! -d $DIRTAGGER ]] && mkdir -p $DIRTAGGER
[[ ! -e $DIRTAGGER/default ]] && echo "1x" > $DIRTAGGER/default
[[ ! -e $DIRTAGGER/$(basename $0).version ]] && echo "10" > $DIRTAGGER/$(basename $0).version

FUNC_addcron()
{
 [[ -n "$(ps|grep cron|grep -v grep)" ]] &&
 {
  /etc/cron/cronmanager.sh stop 1>/dev/null
  grep -v "$(basename $0)" $CRONFILE > $DIRTMP/cron.$(basename $0)
  echo "37 10-23 * * * /usr/bin/$(basename $0)" >> $DIRTMP/cron.$(basename $0)
  cat $DIRTMP/cron.$(basename $0) >  $CRONFILE
  chmod 600 $CRONFILE
  /etc/cron/cronmanager.sh start 1>/dev/null
  [[ -n "$(ps|grep cron|grep -v grep)" ]] &&
  { 
   printf "
    OK


    $(basename $0) wurde erfolgreich fuer
 
    die automatische Ausfuehrung vorbereitet
    
    
   "
   /etc/cron/cronmanager.sh list 
  } 
  exit 0
 } || {
  printf "
   Achtung!
   
   Fuer die automatische Ausfuehrung des $(basename $0) wird das

   \"Cronmanager Plugin\" von thowi bentigt.

   Bitte installieren Sie dieses Plugin und wiederholen diesen 

   Funktionsaufruf!

  "
 }
}

FUNC_()
{
 cd $DIRTMP
 wget http://127.0.0.1/listtimers >/dev/null 2>/dev/null &

 [[ "$TERM" != "linux" ]] && printf "Bitte warten ...\n"
 sleep 10

 cat /dev/null > $DIRTMP/timers.tmp
 [[ "$TERM" = "linux" ]] &&
 {
  [[ -s $DIRTMP/listtimers ]] &&
  {
   grep "repeated=" $DIRTMP/listtimers| \
   tr -d '; '| \
   sed 's/&start=/;"/g'| \
   sed 's/&stop=/";&/g'| \
   sed 's/&stop=/"/g'| \
   sed 's/&id=/";&/g'| \
   cut -d';' -f2,3| \
   sort -u >> $DIRTMP/timers.tmp
  }
  [[ -s $TIMERFILE ]] &&
  {
   grep "repeated=" $TIMERFILE| \
   tr -d '; '| \
   sed 's/begin=/;/g'| \
   sed 's/end=/;/g'| \
   sed 's/serviceref=/;serviceref=/g'| \
   cut -d';' -f2,3| \
   sort -u >> $DIRTMP/timers.tmp
  }
  sort -u $DIRTMP/timers.tmp|tr -d '"'|tr ';' ' ' > $DIRTMP/timers.meta
  while read TIMERSTART TIMERSTOP
  do
   let TIMERSTART=$(echo $TIMERSTART|cut -d'.' -f1)
   let TIMERSTOP=$(echo $TIMERSTOP|cut -d'.' -f1)
   [[ $UPDATINGTIME -ge $TIMERSTART ]] &&
   {
    [[ $UPDATINGTIME -le $TIMERSTOP  ]] &&
    {
     TIMERCHECK="$UPDATINGTIME -ge $TIMERSTART && $UPDATINGTIME -le $TIMERSTOP"
     break
    }
   }
  done < $DIRTMP/timers.meta
  [[ -z $TIMERCHECK ]] && exit 0
 }
 
 cat /dev/null > $DIRTMP/timers.tmp
 [[ -s $DIRTMP/listtimers ]] &&
 {
  [[ "$TERM" != "linux" ]] && ls -l $DIRTMP/listtimers
  grep -v 'repeated=0' $DIRTMP/listtimers| \
  grep repeated| \
  tr -d '; '| \
  sed 's/&name=/;META2LINE="/g'| \
  sed 's/&repeated/";&/g'| \
  sed 's/&descr=/;META3LINE="/g'| \
  sed 's/&start/";&/g'| \
  cut -d';' -f2,4| \
  tr -d "'? "| \
  tr ',' ' '| \
  sort -u >> $DIRTMP/timers.tmp
 }
 [[ -s $TIMERFILE ]] &&
 {
  [[ "$TERM" != "linux" ]] && ls -l $TIMERFILE
  grep -v 'repeated="0"' $TIMERFILE| \
  grep repeated| \
  tr -d '; '| \
  sed 's/name=/;META2LINE=/g'| \
  sed 's/description=/;META3LINE=/g'| \
  sed 's/afterevent=/;afterevent=/g'| \
  cut -d';' -f2,3| \
  tr -d "'? "| \
  tr ',' ' '| \
  sort -u >> $DIRTMP/timers.tmp
 }

 [[ "$TERM" != "linux" ]] && printf "\nBitte warten ...\n"

 ls $DIRMOVIE/*.meta >$DIRTMP/media.meta 2>/dev/null
 while read X
 do
  META2LINE=$(tail +2 "$X"|head -1|tr ')/.' '   '|cut -d'-' -f1|cut -d'(' -f1|tr -d "'?, ")
  echo "META2LINE=\"$META2LINE\";META3LINE=\"\"" >>  $DIRTMP/$UPDATINGTIME.$META2LINE
 done < $DIRTMP/media.meta
 ls $DIRTMP/$UPDATINGTIME.* >$DIRTMP/media.wcl 2>/dev/null
 while read X
 do
  let WCL=$(wc -l "$X"|awk '{print $1}')
  [[ $WCL -ge 2 ]] &&
  {
   head -1 "$X" >> $DIRTMP/timers.tmp
   [[ "$TERM" != "linux" ]] && echo "Treffer[100] $WCL >= 2 -- $X"
  }
  rm -f "$X"
 done < $DIRTMP/media.wcl
 sort -ur $DIRTMP/timers.tmp > $DIRTMP/timers.meta

 [[ "$TERM" != "linux" ]] && printf "\nBitte warten ...\n"

 while read X
 do
  eval "$X"
  META2X=$(echo $META2LINE|tr ')/.' '   '|cut -d'-' -f1|cut -d'(' -f1|tr -d "' ")
  META3X=$(echo $META3LINE|tr ')/.' '   '|cut -d'-' -f1|cut -d'(' -f1|tr -d "' ")
  [[ "$META2X" = "$META3X" ]] &&
  {
   set $META2X
  } || {
   set $META2X $META3LINE
  }
  [[ ! -s $DIRTAGGER/$META2X ]] &&
  {
   echo "$*" > $DIRTAGGER/$META2X
   [[ "$TERM" != "linux" ]] && echo "Treffer[200] $*"
  }
 done < $DIRTMP/timers.meta

 [[ "$TERM" != "linux" ]] && printf "\nBitte warten ...\n"

 while read X
 do
  METADATE=$(basename "$X"|cut -d' ' -f1)
  METASENDER=$(basename "$X"|cut -d'-' -f2|tr -d ":_?"|sed 's/^ //g'|sed 's/ $//g'|tr ' ' '_')
  META2LINE=$(tail +2 "$X"|head -1|tr ')/.' '   '|cut -d'-' -f1|cut -d'(' -f1|tr -d "'?, ")
  META3LINE=$(tail +3 "$X"|head -1|tr ')/.' '   '|cut -d'-' -f1|cut -d'(' -f1|tr -d "'?, ")
  META5LINE=$(tail +5 "$X"|head -1|tr -d ' ')

  [[ -e $DIRTAGGER/$META2LINE ]] &&
  {
   METATAGGER=$(tail +1 "$DIRTAGGER/$META2LINE"|head -1|tr -d ' ')
  } || {
   METATAGGER=$(tail +1 "$DIRTAGGER/default"|head -1|tr -d ' ')
  }

  [[ "$META5LINE" != "$METATAGGER" ]] &&
  {
   [[ "$TERM" != "linux" ]] && echo "Treffer[300] $META5LINE != $METATAGGER"
   META5LINE=""
  }
  [[ "$(tail -1 $DIRTAGGER/$(basename $0).version)" -ne "$VERSION" ]] && META5LINE=""

  [[ -z "$META5LINE" ]] &&
  {
   [[ -e $DIRTAGGER/$META2LINE ]] && 
   { 
    META5LINE="$META2LINE"
   } || {
    META5LINE="default"
   }
   head -4  "$X" > $DIRTMP/media.tmp
   cat $DIRTAGGER/$META5LINE >> $DIRTMP/media.tmp
   cat $DIRTMP/media.tmp > "$X"
   [[ "$TERM" != "linux" ]] &&
   {
    META5LINE=$(tail +5 "$X"|head -1|tr -d ' ')
    echo "Treffer[400] $METADATE -- $METASENDER -- $META5LINE"
   }
  }
 done < $DIRTMP/media.meta

 [[ "$(tail -1 $DIRTAGGER/$(basename $0).version)" -ne "$VERSION" ]] && echo "$VERSION" >> $DIRTAGGER/$(basename $0).version
}

FUNC_list()
{
 export TERM=xterm
 ls $DIRTAGGER/*|grep -v weinbergtagger.sh.version|xargs cat 
}

FUNC_manuell()
{
 export TERM=xterm
 FUNC_
}

FUNC_message()
{
 printf "
 Achtung!
  
 Nach Ausfuehrung von \"$(basename $0) $1\"
   
 erfolgt ein Neustart der DM7025
 "
 init 4
 killall -9 enigma2
 sleep 5
}

FUNC_pre_delete()
{
 cp $0 /var/tmp

 [[ -n "$(ps|grep cron|grep -v grep)" ]] &&
 {
  /etc/cron/cronmanager.sh stop 1>/dev/null
  grep -v "$(basename $0)" $CRONFILE > $DIRTMP/cron.$(basename $0)
  cat $DIRTMP/cron.$(basename $0) >  $CRONFILE
  chmod 600 $CRONFILE
  /etc/cron/cronmanager.sh start 1>/dev/null
 }
 /var/tmp/$(basename $0) now_delete &
}
  
FUNC_now_delete()
{
 FUNC_message deinstallieren
 rm -fr $DIRTAGGER $(find /usr -type d -name "*weinbergtagger*")
 rm -f /usr/bin/$(basename $0)
 reboot
}


FUNC_$*
