#weinbergtagger 20070312

from enigma import *
from Components.ActionMap import ActionMap, NumberActionMap
from Components.GUIComponent import GUIComponent
from Components.HTMLComponent import HTMLComponent
from Components.Input import Input
from Components.Label import Label
from Components.MenuList import MenuList
from Components.MovieList import MovieList
from Components.MultiContent import RT_HALIGN_LEFT, MultiContentEntryText,MultiContentEntryPixmap, MultiContentEntryPixmapAlphaTest
from Components.ScrollLabel import ScrollLabel
from Plugins.Plugin import PluginDescriptor
from Screens.ChoiceBox import ChoiceBox
from Screens.Console import Console
from Screens.ImageWizard import ImageWizard
from Screens.InputBox import InputBox
from Screens.MessageBox import MessageBox
from Screens.Screen import Screen
from ServiceReference import ServiceReference
from enigma import eListboxPythonMultiContent
from skin import parseColor
from Tools.Directories import *
from Components.GUIComponent import *
import os

################################################################
# path to weinbergtagger  - could be also a Link
################################################################
weinbergtagger_path = "/var/tmp"
weinbergtagger_script = "weinbergtagger.sh"
weinbergtagger_readme = "readme.txt"
weinbergtagger_pluginpath = "/usr/lib/enigma2/python/Plugins/Extensions/weinbergtagger"

################################################################
# version
################################################################
weinbergtagger_pluginversion = "2.1"

################################################################
def main(session,**kwargs):
    try:    
     	session.open(weinbergtagger)
    except:
        print "[KEYBACKUP] Pluginexecution failed"
################################################################
def autostart(reason,**kwargs):
    if reason == 0:
        print "[KEYBACKUP] no autostart"
################################################################
def Plugins(**kwargs):
    return PluginDescriptor(
        name="weinbergtagger", 
        description="plugin to do weinbergtagger and restore", 
        where = PluginDescriptor.WHERE_PLUGINMENU,
        fnc = main
        )
################################################################
################################################################
class weinbergtagger(Screen):
    skin = """
        <screen position="100,100" size="500,400" title="weinbergtagger.sh Menu" >
            <widget name="menu" position="10,10" size="490,390" scrollbarMode="showOnDemand" />
        </screen>"""
        
    def __init__(self, session, args = 0):
        self.skin = weinbergtagger.skin
        self.session = session
        Screen.__init__(self, session)
        self.menu = args
        list = []
        list.append((_("weinbergtagger.sh manuell starten"), "manuell"))
        list.append((_("Inhalt der weinbergtagger-Dateien anzeigen"), "list"))
        list.append((_("  "), "  "))        
        list.append((_("weinbergtagger.sh in crontab eintragen"), "addcron"))
        list.append((_("weinbergtagger.sh deinstallieren"), "delete"))
        list.append((_("  "), "  "))        
        list.append((_("History"), "history"))        
        list.append((_("About"), "about"))        
        self["menu"] = MenuList(list)
        self["actions"] = ActionMap(["WizardActions", "DirectionActions"],{"ok": self.go,"back": self.close,}, -1)
        
    def go(self):
        returnValue = self["menu"].l.getCurrentSelection()[1]
        if returnValue is not None:
           if returnValue is "list":
               title = "Listing File(s) at %s" %(weinbergtagger_path)
               cmd = "%s/%s list" % (weinbergtagger_pluginpath,weinbergtagger_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "manuell":
               title = "weinbergtagger.sh %s" %(weinbergtagger_path)
               cmd = "%s/%s manuell" % (weinbergtagger_pluginpath,weinbergtagger_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "addcron":
               title = "weinbergtagger.sh %s" %(weinbergtagger_path)
               cmd = "%s/%s addcron" % (weinbergtagger_pluginpath,weinbergtagger_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "delete":
               title = "weinbergtagger.sh %s" %(weinbergtagger_path)
               cmd = "%s/%s pre_delete" % (weinbergtagger_pluginpath,weinbergtagger_script)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "history":
               title = "weinbergtagger Plugin readme.txt"
               cmd = "cat %s/%s" % (weinbergtagger_pluginpath,weinbergtagger_readme)
               self.session.open(Console,_(title),[cmd])
           elif returnValue is "about":
             self.session.open(MessageBox,_("weinbergtagger.sh Enigma2 Plugin V%s\n\nEnjoy weinbergtagger.sh" % weinbergtagger_pluginversion), MessageBox.TYPE_INFO)

################################################################
################################################################

def main(session, service, **kwargs):
	session.open(weinbergtagger, service)

def Plugins(path,**kwargs):
	global plugin_path
	plugin_path = path
 	return PluginDescriptor(name="weinbergtagger.sh", description=_("weinbergtagger.sh ..."), where = PluginDescriptor.WHERE_MOVIELIST, fnc=main)
